unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, OmegaTimer, OmegaFont, OmegaImageList, OmegaSprite, OmegaScreen,
  OmegaInput, OmegaBitmapFont, OmegaUtils;

type
  TMainForm = class(TForm)
    OmegaScreen: TOmegaScreen;
    OmegaSprite: TOmegaSprite;
    OmegaImageList: TOmegaImageList;
    OmegaFont: TOmegaFont;
    OmegaTimer: TOmegaTimer;
    OmegaBitmapFont: TOmegaBitmapFont;
    OmegaInput: TOmegaInput;
    procedure FormCreate(Sender: TObject);
    procedure OmegaTimerTimer(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure LoadTheDll(name: String);
  end;

var MainForm: TMainForm;

implementation

uses dllLoader;

{$R *.dfm}

// this procedure load our dll and initializes everything
procedure TMainForm.LoadTheDll(name: String);
var s: String;
begin
 LoadDll(name);   // load the dll
 s := GetPicPath; // get the path to our images
 OmegaImageList.ImageList.LoadFromFile(ExtractFilePath(Application.ExeName)+s); // load the images
 OmegaImageList.Init;  // initilialize the imagelist
 InitDll(OmegaScreen, OmegaImageList, OmegaSprite, OmegaFont, OmegaBitmapFont, OmegaInput); // initialize the dll
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
 OmegaScreen.Init;
 LoadTheDll('TheDll1.dll');
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
 OmegaTimer.Enabled := True;
end;

procedure TMainForm.OmegaTimerTimer(Sender: TObject);
begin
 if not OmegaScreen.CanDraw then Exit;
 OmegaScreen.ClearScreen(0,0,0,0);
 OmegaScreen.BeginRender;
 UpdateDll(0); // let the dll do something
 OmegaScreen.EndRender;
 Caption := 'FPS = ' + IntToStr(OmegaTimer.FPS);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
 FreeDLL;
end;

end.
