unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Forms,
  OmegaScreen, OmegaImageList, OmegaTimer, Controls, StdCtrls, Dialogs;

type
  TForm1 = class(TForm)
    OmegaScreen1: TOmegaScreen;
    OmegaImageList1: TOmegaImageList;
    OmegaTimer1: TOmegaTimer;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    procedure FormCreate(Sender: TObject);
    procedure OmegaTimer1Timer(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  end;

var Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
 OmegaTimer1.Enabled:=true;
 OmegaScreen1.Init;
end;

procedure TForm1.OmegaTimer1Timer(Sender: TObject);
begin
 if not OmegaScreen1.CanDraw then exit;
 OmegaScreen1.ClearScreen(0,0,0,0);
 OmegaScreen1.BeginRender;
 if OmegaImageList1.ImageList.Count > 0 then
  OmegaImageList1.ImageList.items[0].Draw(10,10,0);
 OmegaScreen1.EndRender;
end;

const C1 = 52845;
      C2 = 22719;
      password = 1234; // your secret key

// In this example, we use XOR-encryption with periodic modulation
// of key offset, defined by initial condition 'password'
function MyEncrypt(s: TStream): TStream;
var arrbyte: array of byte;
    i, size: Integer;
    Key: Word;
begin
 size := s.Size; SetLength(arrbyte, size);
 s.Position := 0; s.Read(arrbyte[0], SizeOf(arrbyte[0]) * size);
 Key := password;
 for i := 0 to High(arrbyte) do // for every byte in the stream
 begin
  arrbyte[i] := arrbyte[i] xor (Key shr 8);
  Key := (arrbyte[i] + Key) * C1 + C2;
 end;
 s.Position := 0; s.Write(arrbyte[0], SizeOf(arrbyte[0]) * size);
 result := s;
end;

function MyDecrypt(s: TStream): TStream;
var arrbyte: array of byte;
    i, size: Integer;
    r: byte;
    Key: Word;
begin
 size := s.Size; SetLength(arrbyte, size);
 s.Position := 0; s.Read(arrbyte[0], SizeOf(arrbyte[0]) * size);
 Key := password;
 for i := 0 to High(arrbyte) do // for every byte in the stream
 begin
  r := arrbyte[i];
  arrbyte[i] := arrbyte[i] xor (Key shr 8);
  Key := (r + Key) * C1 + C2;
 end;
 s.Position := 0; s.Write(arrbyte[0], SizeOf(arrbyte[0]) * size);
 result := s;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 if not OpenDialog1.Execute then exit;
 OmegaScreen1.ClearScreen(0,0,0,0);
 OmegaImageList1.ImageList.DecodeFunction := nil;
 OmegaImageList1.ImageList.LoadFromFile(OpenDialog1.Filename);
 OmegaImageList1.Init;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 if not OpenDialog1.Execute then exit;
 OmegaScreen1.ClearScreen(0,0,0,0);
 OmegaImageList1.ImageList.DecodeFunction := MyDecrypt;
 OmegaImageList1.ImageList.LoadFromFile(OpenDialog1.Filename);
 OmegaImageList1.Init;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 if not SaveDialog1.Execute then exit;
 OmegaImageList1.ImageList.EncodeFunction := nil;
 OmegaImageList1.ImageList.SaveToFile(SaveDialog1.Filename);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
 if not SaveDialog1.Execute then exit;
 OmegaImageList1.ImageList.EncodeFunction := MyEncrypt;
 OmegaImageList1.ImageList.SaveToFile(SaveDialog1.Filename);
end;

end.
