unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, OmegaMap, OmegaTimer, OmegaInput, OmegaMusic, OmegaFont,
  OmegaImageList, OmegaSprite, OmegaSurface, OmegaScreen, Menus, ExtCtrls,
  StdCtrls,pngimage, OmegaParticleEngine;

type
  TPlayer = class(Tsprite)
    procedure OnCollision(const Sprite: TSprite; const ColX, ColY: integer); override;
  end;

type
  TForm1 = class(TForm)
    OmegaScreen1: TOmegaScreen;
    OmegaSprite1: TOmegaSprite;
    OmegaImageList1: TOmegaImageList;
    OmegaFont1: TOmegaFont;
    OmegaMusic1: TOmegaMusic;
    OmegaInput1: TOmegaInput;
    OmegaTimer1: TOmegaTimer;
    OmegaMap1: TOmegaMap;
    OmegaParticleEngine1: TOmegaParticleEngine;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure OmegaTimer1Timer(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Player : TPlayer;
  Direction : string;
  TheCollision : boolean;
  mycnt, chg, CoinCount : integer;
  Won : boolean;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  chg := 0;
  OmegaScreen1.SethWnd(Form1.Handle);
  OmegaScreen1.Init;
  OmegaImagelist1.Init;
  OmegaMusic1.Init;
  OmegaFont1.CreateFont('verdana',10,[fsbold]);
  OmegaFont1.Color := OmegaColor(255,255,255,255);
  OmegaInput1.Initialize;

  Player := TPlayer.Create(OmegaSprite1);
  Player.X := OmegaScreen1.Width div 2;
  Player.Y := OmegaScreen1.Height div 2;
  Player.Width := 32;
  Player.Height := 32;
  Player.Image := OmegaImageList1.ImageList.Items[0];
  Player.ImageIndex := 4;
  Player.DoCollision := True;
end;

procedure TForm1.FormShow(Sender: TObject);
var a,b : integer;
begin
  OmegaMap1.LoadMap(extractfilepath(Application.ExeName)+ '/level1.omap');

  for a := 0 to OmegaMap1.WidthCount - 1 do
    for b := 0 to OmegaMap1.HeightCount - 1 do
      begin
        if OmegaMap1.Layer1[a,b].ImageIndex =64 then
          begin
            OmegaMap1.Layer1[a,b].DoCollision := True;
          end;
        if OmegaMap1.Layer3[a,b].ImageIndex <> -1 then
          begin
            OmegaMap1.Layer3[a,b].DoCollision := True;
            OmegaMap1.Layer3[a,b].Name := 'Coin';
          end;
      end;

  OmegaMusic1.Songs.Items[0].Play;

  OmegaTimer1.Enabled := True;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  OmegaTimer1.Enabled := False;
end;

procedure TForm1.OmegaTimer1Timer(Sender: TObject);
begin
  OmegaScreen1.ClearScreen(0,0,0,0);
  Omegascreen1.BeginRender;
  OmegaInput1.Update;

      if (oIsLeft in OmegaInput1.Keyboard.States) and (oIsUp in OMegaInPut1.Keyboard.States) then
        begin
          Player.ImageIndex := 0 + chg;
          Direction := 'upleft';
          OmegaMap1.MoveRight(3);
          OMegaMap1.MoveDown(3);
        end

      else

      if (oIsRight in OmegaInput1.Keyboard.States) and (oIsUp in OMegaInPut1.Keyboard.States) then
        begin
          Player.ImageIndex := 0 + chg;
          Direction := 'upright';
          OmegaMap1.MoveLeft(3);
          OMegaMap1.MoveDown(3);
        end

      else

      if (oIsLeft in OmegaInput1.Keyboard.States) and (oIsDown in OMegaInPut1.Keyboard.States) then
        begin
          Player.ImageIndex := 4 + chg;
          Direction := 'downleft';
          OmegaMap1.MoveRight(3);
          OMegaMap1.MoveUp(3);
        end

      else

      if (oIsRight in OmegaInput1.Keyboard.States) and (oIsDown in OMegaInPut1.Keyboard.States) then
        begin
          Player.ImageIndex := 4 + chg;
          Direction := 'downright';
          OmegaMap1.MoveLeft(3);
          OMegaMap1.MoveUp(3);
        end

      else

      if oisLeft in OmegaInput1.Keyboard.States then
        begin
         Player.ImageIndex := 6 + chg;
         Direction := 'left';
         OmegaMap1.MoveRight(3);
        end

      else

      if oisRight in OmegaInput1.Keyboard.States then
        begin
         Player.ImageIndex := 2 + chg;
         Direction := 'right';
         OmegaMap1.MoveLeft(3);
        end

      else

      if oisUp in OmegaInput1.Keyboard.States then
        begin
          Player.ImageIndex := 0 + chg;
          Direction := 'up';
          OmegaMap1.MoveDown(3);
        end

      else

      if oisDown in OmegaInput1.Keyboard.States then
        begin
          Player.ImageIndex := 4 + chg;
          Direction := 'down';
          OmegaMap1.MoveUp(3);
        end;

  OmegaMap1.Layer1Collision(Player);

  if TheCollision = true then
    begin
      if Direction = 'upleft' then
        begin
          Form1.OmegaMap1.MoveLeft(3);
          Form1.OmegaMap1.MoveUp(3);
        end;

      if Direction = 'upright' then
        begin
          Form1.OmegaMap1.MoveRight(3);
          Form1.OmegaMap1.MoveUp(3);
        end;

      if Direction = 'downleft' then
        begin
          Form1.OmegaMap1.MoveLeft(3);
          Form1.OmegaMap1.MoveDown(3);
        end;

      if Direction = 'downright' then
        begin
          Form1.OmegaMap1.MoveRight(3);
          Form1.OmegaMap1.MoveDown(3);
        end;

      if Direction = 'down' then Form1.OmegaMap1.MoveDown(3);
      if Direction = 'up' then Form1.OmegaMap1.MoveUp(3);
      if Direction = 'left' then Form1.OmegaMap1.MoveLeft(3);
      if Direction = 'right' then Form1.OmegaMap1.MoveRight(3);
    end;

  OmegaMap1.Layer3Collision(player);

  OmegaMap1.DrawLayer1;

  inc(mycnt);if mycnt>7 then
  begin
   chg:=1-chg;
   mycnt:=0;
  end;
  Player.Draw;

  OmegaMap1.DrawLayer3;

  OmegaFont1.Print(10,10,'FPS : ' + IntToStr(OmegaTimer1.FPS));
  OmegaFont1.Print(10,30,'Coin Count : ' + IntToStr(CoinCount));

  If Won then OmegaFont1.Print(10,100,'YOU HAVE WON');

  OmegaScreen1.EndRender;
  OmegaMusic1.Loop;
  TheCollision := False;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if ord(key) = 27 then Form1.Close;
end;

procedure TPlayer.OnCollision(const Sprite: TSprite; const ColX, ColY: integer);
begin
  if Sprite.Name = 'Coin' then
    begin
      CoinCount := CoinCount + 1;
      if CoinCount = 10 then Won := True;
      Sprite.Alpha := 0;
      Sprite.X := -2000;
      Form1.OmegaMusic1.Songs.Items[1].Play;
    end;

  TheCollision := True;
end;

end.
