unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, OmegaTimer, OmegaSprite, OmegaImageList,
  OmegaScreen;

type
  TShip1 = class(TSprite)
  private
    Collided: boolean;
    XSpeed: integer;
  public
    Constructor Create(const AParent: TOmegaSprite); override;
    Procedure OnCollision(const Sprite: TSprite; const X, Y: integer); override;
    Procedure Move(const MoveCount: single); override;
  end;

  TShip2 = class(TSprite)
  private
    collided: boolean;
    XSpeed: integer;
  public
    Constructor Create(const AParent: TOmegaSprite); override;
    Procedure OnCollision(const Sprite: TSprite; const X, Y: integer); override;
    Procedure Move(const MoveCount: single); override;
  end;

  TForm1 = class(TForm)
    OmegaScreen1: TOmegaScreen;
    OmegaImageList1: TOmegaImageList;
    OmegaSprite1: TOmegaSprite;
    OmegaTimer1: TOmegaTimer;
    procedure FormCreate(Sender: TObject);
    procedure OmegaTimer1Timer(Sender: TObject);
  private
    { Private declarations }
    OldCount: integer;        //to hold last frame time
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

Constructor TShip1.Create(const AParent: TOmegaSprite);
begin
  inherited Create(AParent);
  Image := Form1.OmegaImageList1.ImageList.Find('Ship1');
  ImageIndex := 0;
  DoCollision := true;      //we want Collision check for this Sprite
  DoPixelcheck := true;       //we also want Pixelcheck, because its nice ;)
  X := 400;                 //Setting Position of the Sprite
  Y := 85 + Random(50);
  Width := 100;
  Height := 40;
  XSpeed := -Random(50)-50;   //Set this Sprite to move left
  Collided := false;        //No collision occured yet
end;

Procedure TShip1.Move(const MoveCount: single);
begin
  if not Collided then
  begin
   X := X + XSpeed * MoveCount;  //This Sprite should move at XSpeed Pixels per second
  end else
  begin
   X := X - XSpeed * MoveCount;  //This Sprite should move at XSpeed Pixels per second
   Y := Y + 100* MoveCount; //if Collided then fall from the Sky :)
   if Y > 600 then Dead;         //if Sprite fell out of the Screen then kill it
  end;
end;

Procedure TShip1.OnCollision(const Sprite: TSprite; const X, Y: integer);
begin
  if Sprite is TShip2 then //if Ship is of type TShip2
  begin
    Collided := true;      //we have a collision!
    DoCollision := false;  //we don't need any more Collisions with this Sprite
    TShip1.Create(Parent); //Create a new Ship
  end;
end;

Constructor TShip2.Create(const AParent: TOmegaSprite);
begin
  inherited Create(AParent);
  Image := Form1.OmegaImageList1.ImageList.Find('Ship2');
  ImageIndex := 0;
  DoCollision := true;      //we want Collision check for this Sprite
  DoPixelcheck := true;       //we also want Pixelcheck, because its nice ;)
  X := 100;                 //Setting Position of the Sprite
  Y := 100 - Random(10);
  Width := 60;
  Height := 40;
  XSpeed := Random(50)+50;  //Set this Sprite to move right
  Collided := false;        //No collision occured yet
end;


Procedure TShip2.Move(const MoveCount: single);
begin
  if not Collided then
  begin
   X := X + XSpeed * MoveCount;  //This Sprite should move at XSpeed Pixels per second
  end else
  begin
   X := X - XSpeed * MoveCount;  //This Sprite should move at XSpeed Pixels per second
   Y := Y + 100* MoveCount; //if Collided then fall from the Sky :)
   if Y > 600 then Dead;         //if Sprite fell out of the Screen then kill it
  end;
end;

Procedure TShip2.OnCollision(const Sprite: TSprite; const X, Y: integer);
begin
  if Sprite is TShip1 then //if Ship is of type TShip1
  begin
    Collided := true;      //we have a collision!
    DoCollision := false;  //we don't need any more Collisions with this Sprite
    TShip2.Create(Parent); //Create a new Ship
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Randomize;
  self.ClientWidth := 640;
  self.ClientHeight := 480;
  OmegaScreen1.Width := self.ClientWidth;
  OmegaScreen1.Height := self.ClientHeight;
  OmegaScreen1.Init;             //Init all the stuff and enable the Timer
  OmegaImageList1.Init;
  OmegaTimer1.Enabled := true;
  OldCount := GetTickCount;
  TShip1.Create(OmegaSprite1);
  TShip2.Create(OmegaSprite1);
end;

procedure TForm1.OmegaTimer1Timer(Sender: TObject);
var
  NewCount: integer; //to hold new frame time
begin
  NewCount := GetTickCount;
  OmegaScreen1.BeginRender;               //We Must call this before rendering
                                          //something
  OmegaScreen1.ClearScreen(0, 0, 0, 255); //Fill the Screen with black

  OmegaImageList1.BeginDraw;              //We Must call this before drawing
                                          //something with the ImageList
  OmegaSprite1.Move((NewCount -
                     OldCount)*0.001);    //Pass frame time in seconds
  OmegaSprite1.Collision;                 //Check for any Collisions;
  OmegaSprite1.Dead;                      //Clear up the dead Sprites
  OmegaSprite1.Draw;                      //Draw our Sprites

  OmegaImageList1.EndDraw;                //We Must call this when we called
                                          //BeginDraw before
  OmegaScreen1.EndRender;                 //We Must call this to finish
                                          //rendering
  OldCount := NewCount;                   //set Old frame time to the new one
end;

end.
