unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, OmegaImageList, OmegaScreen, OmegaTimer,
  OmegaBitmapFont, OmegaSprite, OmegaFader, OmegaInput, {$I UseD3D8.inc};

type
  TForm1 = class(TForm)
    OmegaScreen1: TOmegaScreen;
    OmegaImageList1: TOmegaImageList;
    OmegaTimer1: TOmegaTimer;
    OmegaBitmapFont1: TOmegaBitmapFont;
    Fader: TOmegaFader;
    OmegaInput1: TOmegaInput;
    procedure FormCreate(Sender: TObject);
    procedure OmegaTimer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  end;

var Form1: TForm1;
    angle: single;
    showfader, showspot: boolean;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
 randomize;
 self.ClientWidth := 800;
 self.ClientHeight := 600;
 OmegaScreen1.Width := self.ClientWidth;
 OmegaScreen1.Height := self.ClientHeight;
 OmegaScreen1.Init;
 OmegaInput1.Initialize;
 Fader.SetSourceColor(0, 0, 0, 0);
 Fader.SetDestinationColor(0, 0, 0, 0);
 Fader.MirrorFade := false;
 Fader.LoopFade := false;
 Fader.FadeSpeed := 2;
 showspot := true;
 showfader := false;
 OmegaTimer1.Enabled := True;
end;

procedure TForm1.OmegaTimer1Timer(Sender: TObject);
var x, y: integer;
    s, s2, c, c2,  // sine and cosine variables
    t, t2, t3, t4, t5: single; // temporary variables
begin
 OmegaInput1.Update;
 if oisbutton1 in OmegaInput1.keyboard.statesclicked then
  OmegaScreen1.ToggleFullscreen;
 if not OmegaScreen1.CanDraw then exit;
 OmegaScreen1.BeginRender;
 OmegaScreen1.ClearScreen(0,0,0,0);

 angle := angle + 0.5;
 if angle >= 360 then angle := angle - 360;
 s := sin(angle * pi / 180);
 s2 := sin(pi + (4 * angle * pi / 180));
 c := cos(angle * pi / 180);
 c2 := cos(pi + (4 * angle * pi / 180));

 // draw background
 for x := 0 to 2 do
  for y := 0 to 1 do
   OmegaImageList1.ImageList.Items[1].Draw(
   x*256, y*256, 0, 0, 0, 1, 1,
    OmegaColor(255, 255, 255, 255), -1);

 if showspot then
 begin
  // draw spotlight
  t  := 200 + 200 * s;
  t2 := 100 + 100 * c2;
  t3 := 100 * (s2 + 1.5);  // color movement
  t4 := 100 * (c + 1.5);   // color movement
  t5 := 120 * (s2 + 1.5);  // color movement
  OmegaImageList1.ImageList.Items[0].Draw(
   round(t), round(t2), // position
   0, 0.5, 0.5, // rotation angle and center
   (t + t5) / 200, t5 / 100, // scaling
   OmegaColor(round(t3), round(t4), 255 - round(t3), 255), -1, 1);
 end;

 Fader.Draw;
 if showfader then
 begin
  if Fader.FadeEnded then
  begin
   Fader.SwapColors;
   Fader.SetDestinationColor(random(255), random(255), random(255), random(255));
   Fader.Reset;
  end;
 end;
 OmegaBitmapFont1.Print(240, 300, 'Press "C" to activate color fades');
 OmegaBitmapFont1.Print(240, 320, 'Press "O" to fade out');
 OmegaBitmapFont1.Print(240, 340, 'Press "I" to fade in');
 OmegaBitmapFont1.Print(240, 360, 'Press "X" to activate multi fades');
 OmegaBitmapFont1.Print(240, 380, 'Press "L" to toggle loop mode');
 OmegaBitmapFont1.Print(240, 400, 'Press "M" to toggle mirror mode');
 OmegaBitmapFont1.Print(240, 420, 'Press "R" to reset');
 OmegaBitmapFont1.Print(240, 440, 'Press "S" to toggle spotlight');
 OmegaBitmapFont1.Print(240, 460, 'Press "space" to toggle fullscreen');

 OmegaScreen1.EndRender;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 OmegaTimer1.Enabled := False;
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var c: array[0..6] of TOmegaColor;
begin
 if key = 27 then close;
 if key = ord('S') then showspot := not showspot;
 if key = ord('C') then showfader := not showfader;
 if key = ord('L') then Fader.LoopFade := not Fader.LoopFade;
 if key = ord('M') then Fader.MirrorFade := not Fader.MirrorFade;
 if key = ord('R') then
 begin
  Fader.Stop;
  Fader.SetSourceColor(0, 0, 0, 0);
  Fader.SetDestinationColor(0, 0, 0, 0);
  Fader.MirrorFade := false;
  Fader.LoopFade := false;
  Fader.FadeSpeed := 2;
 end;
 if key = ord('B') then
  Fader.BlendMode := (Fader.BlendMode + 1) mod 14;
 if key = ord('X') then
 begin
  c[0] := OmegaColor(0, 0, 0, 0);
  c[1] := OmegaColor(255, 0, 0, 255);
  c[2] := OmegaColor(0, 0, 0, 0);
  c[3] := OmegaColor(0, 255, 0, 255);
  c[4] := OmegaColor(0, 0, 0, 0);
  c[5] := OmegaColor(0, 0, 255, 255);
  c[6] := OmegaColor(0, 0, 0, 0);
  Fader.FadeSpeed := 3;
  Fader.MultiFade(c);
 end;
 if key = ord('I') then
 begin
  showfader := false;
  fader.PrepareFadeIn(random(255), random(255), random(255), 0.5 + random * 3);
 end;
 if key = ord('O') then
 begin
  showfader := false;
  Fader.PrepareFadeOut(random(255), random(255), random(255), 0.5 + random * 3);
 end;
end;

end.



