unit uMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, OmegaMultimedia;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Timer1: TTimer;
    OmegaMultimedia1: TOmegaMultimedia;
    ScrollBar1: TScrollBar;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ScrollBar1Scroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function BoolToStr(b: Boolean): String;
begin
  Result := 'False';
  if b then Result := 'True';
end;

procedure TForm1.FormCreate(Sender: TObject);
begin  
  OmegaMultimedia1.Init;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  d1,d2: Single;
begin
  OmegaMultimedia1.Render;
  d1 := OmegaMultimedia1.Media.Items[0].Position;
  d2 := OmegaMultimedia1.Media.Items[0].Duration;
  ScrollBar1.Position := Trunc(100 * (d1 / d2));
  Caption := BoolToStr(Omegamultimedia1.Media.Items[0].IsPlaying);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  // if the song is paused then IsPlaying will return false,
  // because of this the following may result in some strange
  // behavior. it all depends on whether or not we want IsPlaying
  // to return false when the song is paused
  if not OmegaMultimedia1.Media.Items[0].IsPlaying then
     omegamultimedia1.Media.Items[0].Play;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  omegamultimedia1.Media.Items[0].Pause;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  omegamultimedia1.Media.Items[0].Stop;
end;

procedure TForm1.ScrollBar1Scroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
var
  temp: Single;
begin
  OmegaMultimedia1.Media.Items[0].Pause;
  temp := ScrollBar1.Position * (OmegaMultimedia1.Media.Items[0].Duration / 100);
  OmegaMultimedia1.Media.Items[0].Position := temp;
  OmegaMultimedia1.Media.Items[0].Pause;
end;

end.
